<template>
  <v-toolbar dense flat class="border-bottom-think post-bar-stick">
    <v-row no-gutters>
      <v-col cols="12" md="5" class="ml-n1">
        <v-autocomplete
          v-model="selected"
          :append-icon="mdiMagnify"
          :loading="isLoading"
          :items="items"
          :search-input.sync="search"
          single-line
          no-data-text="..."
          flat
          no-filter
          dense
          solo
          item-text="name"
          return-object
          color="accent"
          hide-details
          placeholder="Search by location"
        />
      </v-col>
      <v-col class="d-none d-md-flex align-center">
        <v-divider vertical style="height: 33px; margin-right: 18px" />
        <filter-range name="Price" :options="priceOpts" label="Price" />
        <filter-select name="Beds" :options="bedsOpts" label="Beds" />
        <filter-select name="Baths" :options="bathsOpts" label="Baths" />
        <filter-range name="Size" :options="sizeOpts" label="Size" />
        <v-btn class="mr-2" outlined color="accent" small @click="$emit('filter', true)">
          <span class="text-capitalize">
            More
          </span>
          <v-icon right>
            {{ mdiChevronDown }}
          </v-icon>
        </v-btn>
        <v-btn class="mr-2" outlined color="accent" small @click="clearFilter">
          <span class="text-capitalize">
            Clear
          </span>
          <v-icon right>
            {{ mdiClose }}
          </v-icon>
        </v-btn>
      </v-col>
    </v-row>
  </v-toolbar>
</template>

<script lang="ts">
import { mdiClose, mdiChevronDown, mdiMagnify } from '@mdi/js'
import { defineComponent, ref, watch } from '@vue/composition-api'
import { useQuery, useAutocomplete } from '@/hooks'
import FilterRange from '@/components/FilterRange.vue'
import FilterSelect from '@/components/FilterSelect.vue'

const bathsOpts = {
  min: [{ value: 1, text: '1' }, { value: 2, text: '2' }, { value: 3, text: '3' }],
  max: [{ value: 1, text: '1' }, { value: 2, text: '2' }, { value: 3, text: '3' }]
}
const bedsOpts = {
  max: [{ value: 0, text: 'Studio' }, { value: 1, text: '1' }, { value: 2, text: '2' }, { value: 3, text: '3' }],
  min: [{ value: 1, text: '1' }, { value: 2, text: '2' }, { value: 3, text: '3' }]
}
const priceOpts = {
  min: [
    { value: 500, text: '$500' },
    { value: 700, text: '$700' },
    { value: 900, text: '$900' },
    { value: 1100, text: '$1100' },
    { value: 1300, text: '$1300' },
    { value: 1500, text: '$1500' }
  ],
  max: [
    { value: 1100, text: '$1100' },
    { value: 1300, text: '$1300' },
    { value: 1500, text: '$1500' },
    { value: 1700, text: '$1700' },
    { value: 1900, text: '$1900' },
    { value: 2100, text: '$2100' }
  ]
}
const sizeOpts = {
  min: [
    ...Array(16).fill(0).map((_, idx) => ({ value: 400 + idx * 100, text: (400 + idx * 100) + ' sqft' })),
    { value: 2000, text: '2000 sqft' },
    { value: 2500, text: '2500 sqft' },
    { value: 3000, text: '3000 sqft' },
    { value: 3500, text: '3500 sqft' },
    { value: 4000, text: '4000 sqft' },
    { value: 4500, text: '4500 sqft' },
    { value: 5000, text: '5000 sqft' }
  ],
  max: [
    ...Array(16).fill(0).map((_, idx) => ({ value: 400 + idx * 100, text: (400 + idx * 100) + ' sqft' })),
    { value: 2000, text: '2000 sqft' },
    { value: 2500, text: '2500 sqft' },
    { value: 3000, text: '3000 sqft' },
    { value: 3500, text: '3500 sqft' },
    { value: 4000, text: '4000 sqft' },
    { value: 4500, text: '4500 sqft' },
    { value: 5000, text: '5000 sqft' }
  ]
}

export default defineComponent({
  name: 'AppBarFilter',
  components: { FilterRange, FilterSelect },
  setup (_, context) {
    const { isLoading, items, search, setSearch } = useAutocomplete(context)
    const { filters, resetFilters } = useQuery(context)
    const selected = ref<any>({})
    if (filters.value.search) {
      selected.value = {
        name: filters.value.search,
        bounds: filters.value.view ?? []
      }
      items.value.push(selected.value)
    }
    watch(selected, () => {
      setSearch(selected.value)
    }, { lazy: true })
    return {
      bathsOpts,
      items,
      search,
      clearFilter () {
        resetFilters()
        context.emit('filter', false)
      },
      mdiClose,
      mdiChevronDown,
      mdiMagnify,
      isLoading,
      selected,
      bedsOpts,
      priceOpts,
      sizeOpts
    }
  }
})
</script>
